/*--------------------------文档信息-------------------------------------------
///功能：      库存状况表
///创建人：  王群
///创建时间：2011年05月31日
///修改人：  --------------
///修改时间：--------------
///详细说明：--------------
-----------------------------------------------------------------------------*/
//页面全局变量的定义
var strTableP0311 = "Tp0311";    //表格ID
var objSelRowP0311 = {};           //选择行的数据
var intSelRowIDP0311 = 0;        //选择行的ID
var objWhereJsonP0311 = {};    //记录查询时的条件

/*↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓**事件方法 开始**↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓*/
function pageLoad_P0311() {
    try {
        //仓库下拉框信息的加载
        loadCkData_P0311();
        //药品人员的下拉框信息的加载
        loadSpData_P0311();
        //加载数据
        searchDataClick_P0311();
    } catch (e) { }
}

//查询按钮的方法
function searchDataClick_P0311() {
    try {
        var strWhereJson = "";           //存放查询条件
        var objConfig = {};                  //存放列配置
        var objResult = {};                  //存放查询结果
        if (!$("#cmbCKP0311").combobox("getValue")) {   //"当前选择的仓库不存在时，赋值为【全部仓库】"
            $("#cmbCKP0311").combobox("setValue", "");
        }
        if (!$("#cmbSpP0311").combobox("getValue")) {        // "当前选择的药品不存在时，赋值为【去不药品】"
            $("#cmbSpP0311").combobox("setValue", "");
        }
        //清空选择行信息
        intSelRowIDP0311 = 0;
        objSelRowP0311 = {};

        //查询条件的取得
        strWhereJson += "{\"ckdm\":\"" + $("#cmbCKP0311").combobox("getValue") + "\",";
        strWhereJson += "\"spdm\":\"" + $("#cmbSpP0311").combobox("getValue") + "\",";
        strWhereJson += "\"ph\":\"" + ($("#showPhP0311").attr("checked")) + "\",";
        strWhereJson += "\"ck\":\"" + ($("#showCkP0311").attr("checked")) + "\"}";

        //创建列属性
        objConfig = ParseData(window.external.DoOptions(strTableP0311, "GetTableConfig", "{}"));

        //格式化表格中的数据
        setData_P0311(objConfig.colModel);
        objResult = ParseData(window.external.DoOptions(strTableP0311, "GetList", strWhereJson));

        //创建表格
        createGrid_P0311(strTableP0311, objConfig.colNames, objConfig.colModel, objResult.Records);
        //释放内存
        strWhereJson = null;
        objConfig = null;
        objResult = null;
    } catch (e) { }
}

//格式化数据方法
function setData_P0311(objP0311) {
    for (var i = 0; i < objP0311.length; i++) {
        if (objP0311[i].name == "sl") {    //格式化成整数
            objP0311[i].formatter = formatterP0311Count;
        }
        if (objP0311[i].name == "kcje" || objP0311[i].name == "dj") {    //格式化成money
            objP0311[i].formatter = formatterP0311Money;
        }

        if (objP0311[i].name == "a2") {       //控制隐藏还是显示批号那一列
            objP0311[i]["hidden"] = !$("#showPhP0311").attr("checked");
        }
        if (objP0311[i].name == "a4") {        //控制隐藏还是显示有效日期的那一列
            objP0311[i]["hidden"] = !$("#showPhP0311").attr("checked");
        }

        if (objP0311[i].name == "ckkhmc") {   //控制隐藏还是显示仓库列
            objP0311[i]["hidden"] = !$("#showCkP0311").attr("checked");
        }
    }
}
/*↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓**事件方法 结束**↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓*/

/*↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓**自定义方法 开始**↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓*/
//给仓库下拉列表绑定值
function loadCkData_P0311() {
    $("#cmbCKP0311").combobox({
        width: _iWidth120,
        listWidth: _iWidth120,
        valueField: "dm",
        textField: "mc",
        onblur: function () {
            if ($("#cmbCKP0311").combobox("getText") == "") {
                $("#cmbCKP0311").combobox("setValue", "");
            }
        },
        onfocus: function () {
            if ($("#cmbCKP0311").combobox("getText") == "全部仓库") {
                $("#cmbCKP0311").combobox("setText", "");
            }
        }
    });

    //加载数据
    var objDrug = getComboboxData("TCkxx2");
    if (objDrug == "{}") {
        objDrug = [];
    }
    objDrug.unshift({ "dm": "", "mc": "全部仓库", "selected": true });
    $("#cmbCKP0311").combobox("loadData", objDrug);
    //释放内存
    objDrug = null;
}

//给药品下拉框绑定值
function loadSpData_P0311() {
    $("#cmbSpP0311").combobox({
        width: _iWidth120,
        listWidth: _iWidth120,
        valueField: "dm",
        textField: "mc",
        onblur: function () {
            if ($("#cmbSpP0311").combobox("getText") == "") {
                $("#cmbSpP0311").combobox("setValue", "");
            }
        },
        onfocus: function () {
            if ($("#cmbSpP0311").combobox("getText") == "全部药品") {
                $("#cmbSpP0311").combobox("setText", "");
            }
        }
    });

    //加载数据
    var objDrug = getComboboxData("Tspxx2");
    if (objDrug == "{}") {
        objDrug = [];
    }
    objDrug.unshift({ "dm": "", "mc": "全部药品", "selected": true });
    $("#cmbSpP0311").combobox("loadData", objDrug);
    //释放内存
    objDrug = null;
}

//计算合计的方法
function totalCompute_P0311() {
    //设置合计行的数据
    var strKcsl = parseFloat($("#" + strTableP0311).getCol("sl", false, "sum")).toFixed(window.parent.strCountPlace);
    var strKcje = parseFloat($("#" + strTableP0311).getCol("kcje", false, "sum")).toFixed(window.parent.strMoneyPlace);
    var intIDlength = $("#" + strTableP0311).getDataIDs();
    if (intIDlength.length > 0) {
        $("#" + strTableP0311).footerData("set", { rn: "合计", sl: strKcsl, kcje: strKcje }, true);
    }
    else {
        $("#" + strTableP0311).footerData("set", { rn: "合计", sl: "&nbsp;", kcje: "&nbsp;" }, false);
    }
    //释放内存
    strKcsl = null;
    strKcje = null;
    intIDlength = null;
}

//money的格式化
function formatterP0311Money(cellvalue, options, rowObject) {
    if (isNaN(parseFloat(cellvalue))) {
        cellvalue = 0;
    }
    return parseFloat(cellvalue).toFixed(window.parent.strMoneyPlace);
}

//数量的格式化
function formatterP0311Count(cellvalue, options, rowObject) {
    if (isNaN(parseFloat(cellvalue))) {
        cellvalue = 0;
    }
    return parseFloat(cellvalue).toFixed(window.parent.strCountPlace);
}

//当基本资料数据有修改时 刷新相关的combobox
function refreshMyCombobox(strModels) {
    for (var i = 0; i < strModels.length; i++) {
        var data = getComboboxData(strModels[i] + "2");
        if (strModels[i] == "TCkxx") {
            data.unshift({ dm: "", mc: "全部仓库" });
            reLoadCombobox("cmbCKP0311", data);
        }
        if (strModels[i] == "Tspxx") {
            data.unshift({ dm: "", mc: "全部药品" });
            reLoadCombobox("cmbSpP0311", data);
        }
    }
    //释放内存
    data = null;
}

/*↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓**自定义方法 结束**↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓*/

/*-------------------------------------------------------------
功能：创建普通表格
*****①strTableID：表格的ID
*****②objColNames:表格需要显示的列名
*****③objColModel：表格的列配置
*****④objDataRecords：表格中需要加载的数据
-----------------------------------------------------------------*/
function createGrid_P0311(strTableID, objColNames, objColModel, objDataRecords) {
    $("#" + strTableID).GridUnload();        //删除旧表格
    if (objDataRecords == "{}") {               //当数据集为空时，格式化数据集的空值
        objDataRecords = [];
    }
    //生成表格
    $("#" + strTableID).jqGrid({
        datatype: "local",
        sortname: "id",
        colNames: objColNames,
        colModel: objColModel,
        data: objDataRecords,
        rownumbers: true,
        autowidth: true,
        footerrow: true,
        gridview: true,
        rownumWidth: 30,
        cellsubmit: "clientArray",
        rowNum: objDataRecords.length,
        onSelectRow: function (rowId) {//当前选择行数据取得
            intSelRowIDP0311 = rowId;
            objSelRowP0311 = $(this).getRowData(rowId);
        }
    }).parent(".ui-jqgrid-bdiv").siblings().css("width", "100%");

    //设置行号列的名称
    //$("table.ui-jqgrid-htable th:first", $("#gbox_" + strTableID)).text("序号");
    $("#" + strTableID).setLabel("rn", "序号");

    //调整表格的大小
    resizeGrid(strTableP0311, true, false);
    //有滚动条时改变表格宽度
    resizeGridScroll(strTableP0311);
    //合计数据的计算
    totalCompute_P0311();
}

